// [v0.1.003-20250107]

// === module init block ===

// === module extra block (helper functions) ===

// === module main block ===

/***
 * (* constant definitions *)
 */

/**
 * a ref to the `Array.isArray()` method
 * @param {any} value - some value to verify
 * @returns {boolean}
 */
const isArray = Array.isArray;

/***
 * (* function definitions *)
 */

/**
 * @function isObject
 * @param {any} value - some value to verify
 * @returns {boolean}
 * @description Checks whether a given value is an object.
 */
function isObject(value = null) {
  return value !== null && typeof value === 'object';
};

/**
 * @function isPlainObject
 * @param {any} value - some value to verify
 * @returns {boolean}
 * @description Checks if the given value is a plain object
 * @todo consider if an instance of 'Set' or 'Map' can be treated as plain object
 */
function isPlainObject(value = null) {
  return value !== null && typeof value === 'object' && !isArray(value);
};

/***
 * (* class definitions *)
 */

// === module exports block ===

module.exports.isArray = isArray;
module.exports.isObject = isObject;
module.exports.isPlainObject = isPlainObject;
